;****************************************************************************
; Program	: Port Output 01
; Description	: LED Running End-to-End
; For		: MCS-51 Microcontroller Training System
; Filename	: lab1101.ASM
; Environment	: ASEM-51 Macro assembler
; Copyright (C) 2002-2005 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
DRIVER_LE	BIT	P1.4	; Driver Latch Enable (Active High : Level)

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

		ORG	0000H		; Reset Vector
		MOV	P0,#00000000B	; Clear Databus
		SETB	DRIVER_LE	; Enable Driver Latch

MAIN:		MOV	R0,#7		; Set 7 times loop
		MOV	A,#00000001B	; Initial ACC. Value

LOOP_LEFT:	MOV	P0,A		; Out ACC. Value to DATABUS
		ACALL	DELAY_1s	; Delay 1 s
		RL	A		; Rotate ACC. Left
		DJNZ	R0,LOOP_LEFT	; Do loop until 7 times

		MOV	R0,#7		; Set 7 times loop

LOOP_RIGHT:	MOV	P0,A		; Out ACC. Value to DATABUS
		ACALL	DELAY_1s	; Delay 1 s
		RR	A		; Rotate ACC. Right
		DJNZ	R0,LOOP_RIGHT	; Do loop until 7 times

		AJMP	MAIN		; Jump to Main

;----------------------------------------------------------------------------
; Dummy Delay time 10ms,1s
;----------------------------------------------------------------------------
DELAY_10ms:	MOV	R7,#010		; Do 10 times
DELAY_10ms_1:	MOV	R6,#230		; Each loop = 1 ms
DELAY_10ms_2:	NOP
		NOP
		DJNZ	R6,DELAY_10ms_2
		DJNZ	R7,DELAY_10ms_1
		RET

DELAY_1s:	MOV	R5,#100		; Do 100 times
DELAY_1s_1:	ACALL	DELAY_10ms
		DJNZ	R5,DELAY_1s_1
		RET

		END