;****************************************************************************
; Program	: Port Input 01
; Description	: Key Input from S2(P3.2) to "ON" Relay and S3(P3.3) to "OFF"
; For		: MCS-51 Microcontroller Training System
; Filename	: lab1201.asm
; Environment	: ASEM-51 Macro assembler
; Copyright (C) 2002-2005 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
ON_SW		BIT	P3.2	; Interrupt 0 PIN S2
OFF_SW		BIT	P3.3	; Interr2upt 1 PIN S1

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

		ORG	0000H		; Reset Vector
		CLR	P0.4		; Clear Relay

MAIN:		JB	ON_SW,CHK_OFF_SW; Check S2 pressed?
		ACALL	DELAY_10ms	; Delay to avoid switch bounce
		JB	ON_SW,CHK_OFF_SW; Repeat check S2 Pressed?
		SETB	P0.4		; On Relay
		JNB	ON_SW,$		; Wait until S2 depressed
		AJMP	MAIN		; Jump to main

CHK_OFF_SW:	JB	OFF_SW,MAIN	; Check S1 pressed?
		ACALL	DELAY_10ms	; Delay to avoid switch bounce
		JB	OFF_SW,MAIN	; Repeat check S1 Pressed?
		CLR	P0.4		; Off Relay
		JNB	OFF_SW,$	; Wait until S1 depressed
		AJMP	MAIN		; Jump to main

;----------------------------------------------------------------------------
; Dummy Delay time 10m
;----------------------------------------------------------------------------
DELAY_10ms:	MOV	R7,#010		; Do 10 times
DELAY_10ms_1:	MOV	R6,#0E6H	; Each loop = 1 ms
DELAY_10ms_2:	NOP
		NOP
		DJNZ	R6,DELAY_10ms_2
		DJNZ	R7,DELAY_10ms_1
		RET

		END