;****************************************************************************
; Program	: Timer 01
; Description	: Square Wave Generator 500Hz on T0 pin (P3.4)
; For		: MCS-51 Microcontroller Training System
; Filename	: lab2401.asm
; Environment	: ASEM-51 Macro assembler
; Copyright (C) 2002-2005 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
T0_PIN		BIT	P3.4		; Timer/Counter 0 PIN

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

		ORG	0000H		; Reset Vector
		AJMP	MAIN		; Jump to Main

		ORG	0003H		; IE0 Vector
		RETI			; Return interrupt

		ORG	000BH		; TF0 Vector
		; add here
		AJMP	INT_T0_SERVICE

		ORG	0013H		; IE1 Vector
		RETI			; Return interrupt

		ORG	001BH		; TF1 Vector
		RETI			; Return interrupt

		ORG	0023H		; TI+RI Vector
		RETI			; Return interrupt

		ORG	002BH		; TF2+EXF2 Vector
		RETI			; Return interrupt

MAIN:		MOV	TMOD,#021H	; T1 8Bit Auto, T0 16Bit
		MOV	TH0,#0FCH	; 1 ms Interval Time
		MOV	TL0,#066H	;

		MOV	IE,#10000010B	; En. EA,ET0

		SETB	TR0		; Start Timer 0
		AJMP	$		; Jump to Main loop

		; add here
INT_T0_SERVICE:	JB	T0_PIN,T_OFF_RELOAD
T_ON_RELOAD:	MOV	TH0,#0FEH	; 1 ms Interval Time
		MOV	TL0,#033H	;
		SETB	T0_PIN		;
		RETI

T_OFF_RELOAD:	MOV	TH0,#0FAH	; 1 ms Interval Time
		MOV	TL0,#09AH	;
		CLR	T0_PIN		;
		RETI			; Return interrupt

		END